﻿Module Module1
    Dim kód() As Integer = {2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5, 6, 6, 6, 7, 7, 7, 7, 8, 8, 8, 9, 9, 9, 9}
    Dim szavak(600) As String       'A beolvasott szavakat tartalmazó tömb, 1-től számozzuk
    Dim n As Integer                'A beolvasott szavak száma
    Dim kódok(600) As String        'Ebbe kerülnek a kódjaik

    Sub Main()
        Feladat1()
        Feladat2()
        Feladat3()
        Feladat4()
        Feladat5()
        Feladat6()
        Feladat7()
        Feladat8()
        Feladat9()

        Console.ReadLine()
    End Sub

    Sub Feladat1()
        Console.Write("Adjon meg egy betűt= ")
        Dim betű = Console.ReadLine()
        Console.WriteLine("Kódja= " & kód(AscW(betű) - 97))
        Console.WriteLine()
    End Sub

    Sub Feladat2()
        Console.Write("Adjon meg egy szót= ")
        Dim szó = Console.ReadLine()

        Console.Write("Kódja= ")
        For i As Integer = 0 To szó.Length - 1
            Console.Write(kód(AscW(szó(i)) - 97))
        Next
        Console.WriteLine()
        Console.WriteLine()
    End Sub

    Sub Feladat3()
        Dim fájl As IO.FileStream = New IO.FileStream("..\..\szavak.txt", IO.FileMode.Open)
        Dim olvasó As IO.StreamReader = New IO.StreamReader(fájl)
        n = 0
        While (olvasó.Peek > -1)
            n += 1
            szavak(n) = olvasó.ReadLine
        End While
        fájl.Close()
    End Sub

    Sub Feladat4()
        Dim max, maxh As Integer

        max = szavak(1).Length
        maxh = 1
        For i As Integer = 2 To n
            If szavak(i).Length > max Then
                max = szavak(i).Length
                maxh = i
            End If
        Next
        Console.WriteLine("A leghosszabb szó= " & szavak(maxh) & ", hossza= " & max)
        Console.WriteLine()
    End Sub

    Sub Feladat5()
        Dim s As Integer = 0

        For i As Integer = 1 To n
            If szavak(i).Length < 6 Then
                s += 1
            End If
        Next
        Console.WriteLine("A legfeljebb 5 karakter hosszú szavak száma = " & s)
        Console.WriteLine()
    End Sub

    Sub Feladat6()
        Dim fájl As IO.FileStream = New IO.FileStream("..\..\kodok.txt", IO.FileMode.Create)
        Dim író As IO.StreamWriter = New IO.StreamWriter(fájl)
        Dim str As String   'Az aktuális szó kódja

        For i As Integer = 1 To n
            str = ""
            For j As Integer = 0 To szavak(i).Length - 1
                str = str & kód(AscW(szavak(i).Chars(j)) - 97) 'Ld. 1. feladat
            Next
            kódok(i) = str    'Feltöltjük a kódok tömböt is a következő feladathoz       
            író.WriteLine(str)
        Next
        író.Close()
        fájl.Close()
    End Sub

    Sub Feladat7()
        Dim számsor As String

        Console.Write("Egy számsor= ")
        számsor = Console.ReadLine()
        Console.Write("A neki megfelelő szavak= ")
        'Valahányszor megtaláljuk a kódok tömbben, kiíratjuk a megfelelő szót a szavakból
        For i As Integer = 1 To n
            If kódok(i) = számsor Then
                Console.Write(szavak(i) & " , ")
            End If
        Next
        Console.WriteLine()
        Console.WriteLine()
    End Sub

    Sub Feladat8()
        'Előbb rendezzük a kódok tömböt és vele együtt a szavak tömböt is
        Dim str As String
        For i As Integer = 1 To n
            For j As Integer = 1 To n - i
                If kódok(j) > kódok(j + 1) Then
                    str = kódok(j)
                    kódok(j) = kódok(j + 1)
                    kódok(j + 1) = str
                    str = szavak(j)
                    szavak(j) = szavak(j + 1)
                    szavak(j + 1) = str
                End If
            Next
        Next

        Console.WriteLine("Ismétlődő szavak:")
        'Végigfutunk a kódok tömbön, s ha az előzővel azonos, kiírjuk a szavakkal együtt
        'volte jelzi, hogy volt-e már egyezés az azonos kóddal

        Dim volte = False
        For i As Integer = 2 To n
            If kódok(i) = kódok(i - 1) Then
                If volte = True Then
                    Console.Write(szavak(i) & " : " & kódok(i) & "; ")
                Else
                    volte = True
                    Console.Write(szavak(i - 1) & " : " & kódok(i - 1) & "; ")
                    Console.Write(szavak(i) & " : " & kódok(i) & "; ")
                End If
            Else
                volte = False
            End If
        Next
        Console.WriteLine()
        Console.WriteLine()
    End Sub

    Sub Feladat9()
        Dim s = 0       'Az adott kód hányszor szerepel
        Dim max, maxh   'A leggyakoribb kód száma, és utolsó helye
        max = 1
        maxh = 1
        For i = 2 To n
            If kódok(i) = kódok(i - 1) Then
                s = s + 1
            End If
            If kódok(i) <> kódok(i - 1) And s > 1 Then
                If s > max Then
                    max = s
                    maxh = i - 1
                End If
                s = 1
            End If
        Next

        Console.WriteLine("A leggyakoribb kód a " & kódok(maxh) & ", " & max & "-szor fordul elő:")
        'Kiíratjuk
        For i = 1 To n
            If kódok(i) = kódok(maxh) Then
                Console.Write(szavak(i) & ", ")
            End If
        Next
        Console.WriteLine()
        Console.WriteLine()
    End Sub
End Module
